#include <SPI.h>
#include <Ethernet.h>
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED }; //Indirizzo fisico della scheda Ethernet
byte ip[] = { 192,168,1, 89 }; //indirizzo IP della scheda Ethernet
EthernetServer server(80); //Porta 80 per il traffico in  HTML
String query;
String TITOLO = "LETTURA DATI By Fabio";
String colore_01 = "green";
String colore_02 = "green";
String colore_03 = "green";
String colore_04 = "green";
String nome_tasto_01 = "SENSORE 01";
String nome_tasto_02 = "SENSORE 02";
String nome_tasto_03 = "SENSORE 03";
String nome_tasto_04 = "SENSORE 04";
byte a = 0;
unsigned int time_1 = 0;
void setup()
{
  pinMode(23, INPUT_PULLUP);
  Serial.begin(9600);
  Serial1.begin(9600);
  query = String("");
  Ethernet.begin(mac, ip); //Inizializzazione Ethernet
  server.begin(); //Il server (Scheda Ethernet Arduino)si mette in ascolto  
}
void loop()
{   
  if(time_1++  == 1000)
  {
      Serial1.write(0);     
      time_1 = 0;
  }
  if(Serial1.available())
  {
     a = Serial1.read(); 
     if(bitRead(a,4) == 1)
     {
        if(bitRead(a,0) == 1)
          colore_01 = "red";
        else
          colore_01 = "green";
     }
     else
     {
        colore_01 = "yellow";
     }
     if(bitRead(a,5) == 1)
     {
        if(bitRead(a,1) == 1)
          colore_02 = "red";
        else
          colore_02 = "green";
     }
     else
     {
        colore_02 = "yellow";
     }
     if(bitRead(a,6) == 1)
     {
        if(bitRead(a,2) == 1)
          colore_03 = "red";
        else
          colore_03 = "green";
     }
     else
     {
        colore_03 = "yellow";
     }  
     if(bitRead(a,7) == 1)
     {
        if(bitRead(a,3) == 1)
          colore_04 = "red";
       else
          colore_04 = "green";
     }
     else
     {
        colore_04 = "yellow";
     }
  }
  EthernetClient client = server.available(); //server.available()restituisce "vero" se il client (browser sul nostro computer) invia messaggi, se no "falso" 
  if (client) // Se è arrivato una richesta (GET / HTTP/1.1 GET /favicon.ico HTTP/1.1)dal client l'IF esegue il suo corpo, se no torna a void loop.
  {
    while (client.connected()) //Il client rimane connesso fino a quando non è stato spedito l'ultimo carattere
    {
      if (client.available()) //client.available restituisce il numero di byte da leggere (se no da 0);
      {
        char c = client.read(); //Legge un byte alla volta
        query.concat(c); //lo concatena in query
        if (c == '\n') // Fintanto non legge il carattere \n seguita la lettura.
        {
          client.println("HTTP/1.1 200 OK"); //Se è stato letto il carattere /n, il server (Ethernet Arduino) risponde con le seguenti tre istruzioni.
          client.println("Content-Type: text/html");
          client.println();
//*******************Tra gli asterischi la pagina HTML****************************************************************************************
          client.print("<!DOCTYPE html PUBLIC '-//W3C//DTD HTML 4.01//EN' 'http://www.w3.org/TR/html4/strict.dtd'>");
          client.print("<html><head>");
          client.print("<meta http-equiv='refresh' content='1;URL= http://192.168.1.89'>");//autoaggiornamento
          client.print("<meta content='text/html; charset=UTF-8' http-equiv='content-type'><title>T</title>");
          client.print("</head>");
          client.print("<body>");
          client.print("<div style='text-align: center;'>");
          client.print("<big>");
          client.print(TITOLO);
          client.print("</big><br>");
          client.print("<br>");
          client.print("<br>");
          client.print("<br>");
          client.print("<br>");
          client.print("<br>");
          client.print("<br>");
          client.print("<br>");
          client.print("<div style='text-align: left;'> &nbsp; &nbsp;");
          client.print("&nbsp; &nbsp; &nbsp;");

          client.print("<table style='background-color: black; width: 50px; height: 50px; text-align: left; margin-left: auto; margin-right: auto;' border='1' cellpadding='5' cellspacing='2'>");
          client.print("<tbody>");
          client.print("<tr>");
          client.print("<th style='white-space: nowrap; text-align: center; vertical-align: middle; background-color: ");
          client.print(colore_01);
          client.print(";'>");
          client.print(nome_tasto_01);          
          client.print("</th>");
          client.print("</tr>");
          client.print("</tbody>");
          client.print("</table>");
          client.print("<br>");

          client.print("<table style='background-color: black; width: 50px; height: 50px; text-align: left; margin-left: auto; margin-right: auto;' border='1' cellpadding='5' cellspacing='2'>");
          client.print("<tbody>");
          client.print("<tr>");
          client.print("<th style='white-space: nowrap; text-align: center; vertical-align: middle; background-color: ");
          client.print(colore_02);
          client.print(";'>");
          client.print(nome_tasto_02);          
          client.print("</th>");
          client.print("</tr>");
          client.print("</tbody>");
          client.print("</table>");
          client.print("<br>");

          client.print("<table style='background-color: black; width: 50px; height: 50px; text-align: left; margin-left: auto; margin-right: auto;' border='1' cellpadding='5' cellspacing='2'>");
          client.print("<tbody>");
          client.print("<tr>");
          client.print("<th style='white-space: nowrap; text-align: center; vertical-align: middle; background-color: ");
          client.print(colore_03);
          client.print(";'>");
          client.print(nome_tasto_03);          
          client.print("</th>");
          client.print("</tr>");
          client.print("</tbody>");
          client.print("</table>");
          client.print("<br>");

          client.print("<table style='background-color: black; width: 50px; height: 50px; text-align: left; margin-left: auto; margin-right: auto;' border='1' cellpadding='5' cellspacing='2'>");
          client.print("<tbody>");
          client.print("<tr>");
          client.print("<th style='white-space: nowrap; text-align: center; vertical-align: middle; background-color: ");
          client.print(colore_04);
          client.print(";'>");
          client.print(nome_tasto_04);          
          client.print("</th>");
          client.print("</tr>");
          client.print("</tbody>");
          client.print("</table>");
          client.print("<br>");

          client.print("</div>");
          client.print("</div>");
          client.print("</body></html>");
//********************************************************************************************************************************************
          break;//Esce dal ciclo    
        }
     }
  }
     delay(1); //Quando il Server ha risposto ad Arduino e stampato la pagina HTML nel browser resetta il processo e torna ad ascoltare
     client.stop();
     query = String("");
  }
}
